package mmql

type TokenType int

type Token struct {
    Type TokenType
    Value string
}

const (
    K_SPACES = "\t\n\r "
    // Must be defined in pairs with
    // open bracket on left and close bracket on right
    K_BRACKETS = "()[]{}"
    K_QUOTES = "'\"`"
)

const (
    UnknownToken TokenType = iota
    KeywordToken
    BracketToken
    SquareBracketToken
    CurlyBracketToken
    SingleQuote
    DoubleQuote
    AccuteAccentQuote
)

var KEYWORDS = []string {
    "ANYWHERE",
    "BOUGHT",
    "BUY",
    "CREATE",
    "EVERY",
    "EXCHANGE",
    "FOR",
    "FROM",
    "GET",
    "LIMIT",
    "LIST",
    "OF",
    "SELL",
    "SOLD",
    "TRIGGER",
    "TRIGGERS",
    "TYPE",
    "UPDATE",
    "WITH",
}

var STATEMENTS = map[string] func( *Lexer ) ( IStatement, error ) {
    "BUY": _buyStatement,
}
