package mmql

/*
EXPECT: BUY
THEN EXPECT: [AmountType] OF [ProductType]
THEN EXPECT: FOR [AmountType]
THEN EXPECT: FROM [ExchangeType]
THEN OPT EXPECT: [ExchangeType]
THEN OPT EXPECT: [AND|OR]
    THEN EXPECT: [ActionExpression]
THEN OPT EXPECT: FOR EVERY
    THEN EXPECT: [AmountType] OF [ProductType]
    THEN EXPECT: [SOLD|BOUGHT] FROM [ExchangeType]
*/

func _buyStatement( lexer *Lexer ) ( IStatement, error ) {
    a := OrderStatement{}

    ex := LexerExpect{
        statements: true,
        keywords: false,
        brackets: false,
        quotes: false,
        key: "AMOUNT",
    }

    stmt, err := lexer.ReadStatement( &ex )
    if err != nil {
        return nil, err
    }
    a.For( stmt )

    var b IStatement = a
    return b, nil
}
